/* MACHINE-GENERATED - DO NOT EDIT ! */

#ifndef _LINUX_ABISS_MSG_TEST_H
#define _LINUX_ABISS_MSG_TEST_H

/*
 * include/linux/abiss_msg_test.h - ABISS messages of the "test" scheduler
 *
 * Written 2003,2004 by Werner Almesberger
 * 
 * (C) Copyright Koninklijke Philips Electronics NV 2004. All rights reserved.
 * 
 * You can redistribute and/or modify this software under the terms of
 * version 2 of the GNU General Public License as published by the Free
 * Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include <stdint.h>
#include <sys/types.h>
#include <abiss_msg.h>


/* ----- abiss_attach ------------------------------------------------------ */



struct abiss_sched_test_prm {
	size_t ra_bytes;	/* read-ahead bytes */
	size_t batch_bytes;	/* number of bytes to load before we start
				   reading */
	int fill_Bps;		/* fill rate in _bytes_ per second, 0 for BE */
	size_t consider_write;	/* if non-zero, try to see what happens if
				   extending the file by that many bytes
				   (development only - do not use) */
	unsigned long _rsv_0;	/* reserved for future use.
	unsigned long _rsv_1;    * MUST
	unsigned long _rsv_2;    * BE
	unsigned long _rsv_3;    * ZERO ! */
};

struct abiss_alloc_test_prm {
	size_t min_contiguous;	/* allocate at least that many bytes at once */
};


/* ----- abiss_sched_msg --------------------------------------------------- */


enum abiss_sched_test {
	abiss_st_time_s,	/* simulate time moving (in seconds) */
	abiss_st_time_ms,	/* idem, in milliseconds */
	abiss_st_time_us,	/* idem, in microseconds */
	abiss_st_time_jiffies,	/* idem, in jiffies */
	abiss_st_query,		/* query playout buffer status */
};


struct abiss_sched_test_msg {
	struct abiss_msg header;
	enum abiss_sched_test type;
	union {
		struct {
			unsigned long new_time;	/* time in above unit */
			int relative;		/* 1 if relative to curr time */
		} time;
		struct abiss_st_query {
			char *page_state;	/* or NULL */
				/*
				 * 'X'	   page not in file
				 * 'U'	   page is up to data and locked
				 * 'R'...  pending request
				 */
			int pages;		/* page_state length, in/out */
						/* ignored if !page_state  */
			int ra_pages;		/* pl.pt. offset, out */
			loff_t playout;		/* kernel playout point */
			loff_t playout_goal;	/* user playout point */
			int credit;		/* current credit (bytes) */
			int max_credit;		/* maximum credit (bytes) */
		} query;
	} u;
};


#endif /* _LINUX_ABISS_MSG_TEST_H */
