/*
* Copyright (c) 2004 Koninklijke Philips Electronics N.V.
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of version 2 of the GNU General Public License as published
* by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
* version 2 for more details.
*/

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <sys/types.h> 

/* Standard POSIX interface, overridden, see eg. man fopen */

FILE*   abiss_fopen( const char *path, const char *mode, 
                     const int byterate, const int app_buffer );
int     abiss_fclose( FILE *fp );
size_t  abiss_fread( void *ptr, size_t size, size_t nmemb, FILE *fp );
size_t  abiss_fwrite( const void *ptr, size_t size, size_t nmemb, FILE *fp ); 
int     abiss_fseek( FILE *fp, long offset, int whence );
int     abiss_fseeko( FILE *fp, off_t offset, int whence );
long    abiss_ftell( FILE *fp );
off_t   abiss_ftello( FILE *fp );

int     abiss_open( const char *path, int flags, mode_t mode, 
                    const int byterate, const int app_buffer );
int     abiss_close( int fd );
ssize_t abiss_read( int fd, void *buf, size_t count );
ssize_t abiss_write( int fd, void *buf, size_t count );
off_t   abiss_lseek( int fd, off_t offset, int whence );

/* functions for test purposes */
off_t abiss_get_playoutpoint_fd( int fd );
off_t abiss_get_playoutpoint_fp( FILE *fp );

#ifdef __cplusplus
}
#endif
